from utils import find_noise_features, extract_basic_features
import numpy as np
from scipy import io
import sys
import xgboost as xgb


def predict(path):

    data = io.loadmat(path)['val'][0]
    features_noise = np.zeros((5, ))

    snr, rr_num, var, fr, fr2 = find_noise_features(data)
    features_noise[0] = snr
    features_noise[1] = rr_num
    features_noise[2] = var
    features_noise[3] = fr
    features_noise[4] = fr2
    features = extract_basic_features(data, 30000)
    features = np.hstack((features, features_noise.reshape(1, -1)))

    mean_ = np.array([15.96300284066109753667, 0.00412371298595770857, 38811.34497233365254942328,
                      0.48050717744965593115, 0.14397582347542958736])
    scale_ = np.array([4.22917401559752281770, 0.00093664880988427878, 62350.76443798459513345733,
                       0.15396567666240373873, 0.07085474966801086349])
    features_noise -= mean_
    features_noise /= scale_

    prediction = 0
    if features_noise[0] < -2.9:
        prediction = 3
    if features_noise[2] > 6.0:
        prediction = 3
    if features_noise[3] > 3.0:
        prediction = 3
    if features_noise[4] < -2.0:
        prediction = 3

    # if prediction == 3:
    #     return prediction

    bst = xgb.Booster({'nthread': 4})
    bst.load_model("xgb.bin")

    dfeatures = xgb.DMatrix(features)
    prediction_prob = bst.predict(dfeatures)
    prediction = np.argmax(prediction_prob)

    return prediction


def run(filename):

    prediction = predict(filename)
    print(prediction)

    if prediction == 0:
        result = 'N'
    elif prediction == 1:
        result = 'A'
    elif prediction == 2:
        result = 'O'
    elif prediction == 3:
        result = '~'

    text = filename + ',' + result + '\n'
    with open("answers.txt", "a") as myfile:
        myfile.write(text)


if __name__ == "__main__":

    run(sys.argv[1])
    # result = predict('training2017/A04735.mat')
    # print(result)
